//+------------------------------------------------------------------+
//|                                              NEW BUY SELL SIGNAL |
//+------------------------------------------------------------------+

//---- indicator settings

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 DarkOrange
#property indicator_width1 2
#property indicator_width2 2

extern int Bollinger_Period  = 20;
extern double Bollinge_StDe  = 2;
extern int FastMA            = 13;
extern int SlowMA            = 34;
extern int RSI_length        = 12;
extern int Filter_Bar_Period = 14;
extern int arrowup           = 171;
extern int arrowdown         = 171;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";

int y = 0,Bollinger_Shift = 0;




//+------------------------------------------------------------------+
//| Custom indicator buffer initialization function                         |
//+------------------------------------------------------------------+

double buysignal[];
double sellsignal[];
double trend[];

int init() {
   IndicatorBuffers(3);
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, arrowup);
   SetIndexBuffer(0, buysignal);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, arrowdown);
   SetIndexBuffer(1, sellsignal);
   SetIndexBuffer(2, trend);
   return (0);
}

//+------------------------------------------------------------------+
//|  indicator calculations                                          |
//+------------------------------------------------------------------+

int start() {
   int counted_bars = IndicatorCounted();
    if (counted_bars < 0) return (-1);
    if (counted_bars > 0) counted_bars--;
    int limit = MathMin(Bars - counted_bars,Bars-1);
   
   for (int i = limit; i >=0; i--) 
   {
      trend[i] = trend[i+1];
      double fastma1 = iMA(NULL, 0, FastMA, 0, MODE_EMA, PRICE_CLOSE, i);
      double fastma2 = iMA(NULL, 0, FastMA, 0, MODE_EMA, PRICE_CLOSE, i + 1);
      
      double slowma1 = iMA(NULL, 0, SlowMA, 0, MODE_EMA, PRICE_CLOSE, i);
      double slowma2 = iMA(NULL, 0, SlowMA, 0, MODE_EMA, PRICE_CLOSE, i + 1);
      
      double rsi1 = iRSI(NULL, 0, RSI_length, PRICE_CLOSE, i);
      double rsi2 = iRSI(NULL, 0, RSI_length, PRICE_CLOSE, i + 1);
      
      double bullspower1 = iBullsPower(NULL, 0, 50, PRICE_CLOSE, i);
      double bullspower2 = iBullsPower(NULL, 0, 50, PRICE_CLOSE, i + 1);
      
      double bearspower1 = iBearsPower(NULL, 0, 50, PRICE_CLOSE, i);
      double bearspower2 = iBearsPower(NULL, 0, 50, PRICE_CLOSE, i + 1);
      
      double upper_b_bands1 = iBands(NULL, 0, Bollinger_Period, Bollinge_StDe, Bollinger_Shift, PRICE_CLOSE, MODE_UPPER, i);
      double lower_b_bands1 = iBands(NULL, 0, Bollinger_Period, Bollinge_StDe, Bollinger_Shift, PRICE_CLOSE, MODE_LOWER, i);
      
      double upper_b_bands2 = iBands(NULL, 0, Bollinger_Period, Bollinge_StDe, Bollinger_Shift, PRICE_CLOSE, MODE_UPPER, i + 1);
      double lower_b_bands2 = iBands(NULL, 0, Bollinger_Period, Bollinge_StDe, Bollinger_Shift, PRICE_CLOSE, MODE_LOWER, i + 1);
      
      double range = 10.0*(iHighest(NULL, 0, MODE_LOW, Filter_Bar_Period, i) - iHighest(NULL, 0, MODE_HIGH, Filter_Bar_Period, i));
      
      if (range >= 0.0) {bool a0 = TRUE;bool b0 = FALSE;} else { if (range < 0.0) { a0 = FALSE; b0 = TRUE; } } 
      
      if (fastma1 > slowma1 && fastma2 < slowma2) {bool a1 = TRUE ; bool b1 = FALSE;}
      if (fastma1 < slowma1 && fastma2 > slowma2) {     a1 = FALSE;      b1 = TRUE;}
      
      if (rsi1 > 50.0 && rsi2 < 50.0) {bool a2 = TRUE ; bool b2 = FALSE;}
      if (rsi1 < 50.0 && rsi2 > 50.0) {     a2 = FALSE;      b2 = TRUE;}
            
      if (Close[i] > upper_b_bands1 && Close[i + 1] >= upper_b_bands2) {bool a3 = FALSE; bool  b3 = TRUE; }
      if (Close[i] < lower_b_bands1 && Close[i + 1] <= lower_b_bands2) {     a3 = TRUE ;       b3 = FALSE;}
      
      if (bullspower1 > 0.0 && bullspower2 > bullspower1) {bool a4 = FALSE; bool b4 = TRUE;}
      if (bearspower1 < 0.0 && bearspower2 < bearspower1) {     a4 = TRUE ;      b4 = FALSE;}
      
           
         if (a0 == TRUE  && a1 == TRUE && a2 == TRUE && a3 == TRUE && a4 == TRUE) trend[i] = 1; 
         if (b0 == FALSE && b1 == TRUE && b2 == TRUE && b3 == TRUE && b4 == TRUE) trend[i] =-1;
         
         //
         //
         //
         //
         //
         
         buysignal[i]  = EMPTY_VALUE;
         sellsignal[i] = EMPTY_VALUE;
         if (trend[i] !=trend[i+1])
         if (trend[i] == 1)
               buysignal[i]  =  Low[i] - iATR(NULL,0,20,i)/2.0;
         else  sellsignal[i] = High[i] + iATR(NULL,0,20,i)/2.0;
         }
         
         if (alertsOn)
         {
           if (alertsOnCurrent)
               int whichBar = 0;
           else     whichBar = 1;
           if (trend[whichBar] != trend[whichBar+1])
           if (trend[whichBar] == 1)
                 doAlert("uptrend");
           else  doAlert("downtrend");       
         }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," new_buysell ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," new_buysell "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
